;http://www.cpcwiki.eu/index.php/Programming:Precalculated_square
;INITSQ		LD DE, 1	;1st odd number
;		LD HL, 0	;HL = 1st square number
;		LD B, H		;counter = 256
;		LD IX, SQTAB	;startaddress of the square table
;SQLOOP		LD (IX), L	;Lowbyte to table
;		INC IX
;		LD (IX), H	;Highbyte to table
;		INC IX
;		ADD HL, DE	;add odd number
;		INC DE		;next odd number
;		INC DE
;		DJNZ SQLOOP	;256 times
;		RET

	device zxspectrum128
;        ORG #5800
; db 2,2*8+6,6*8+4,4*8+5,5*8+1,8
        ORG #6000
begin
;fill grid
	ld hl,$4000
fg:
	ld a,h
	rra
	sbc a,a
	xor $55
	ld (hl),a
	inc hl
	ld a,h
	cp $58
	jr nz,fg
	
;	jr $
ct=$BD00
sqt=$BE00
	ld de,1
	ld hl,0
	exx
	ld hl,sqt
	ld bc,hl;sqt
	exx
gens:
	push hl
	exx
	pop de
	ld (hl),e:inc h
	ld (hl),d:dec h
	ld a,e
	ld (bc),a:inc b
	ld a,d
	ld (bc),a:dec b
	dec c
	inc l
	ld a,l
	cp 129
	exx
	jp z,nex_gen
	add hl,de
	inc de,de
	jr gens
nex_gen:
;41
;build colors
	ld hl,ct
	ld bc,colors
b_c:
	ld a,(bc)
	inc bc
	cp $FF
	jr nz,nolc
	ld bc,colors
	ld a,(bc)
nolc:
	ld (hl),a
	inc l
	jr nz,b_c

rlp:
	ei:halt
	ld hl,$8800
	ld de,$5800
	ld bc,768
	push hl
	ldir
	pop bc;ld bc,$8800
	ld a,24
ylp:
	exa
xlp:
;r.u=((x-x1)*(x-x1)+(y-y1)*(y-y1))!((x-x2)*(x-x2)+(y-y2)*(y-y2))
;    c.a=(r>>7)%9;&15
	ld a,c
	and 31
x1: sub 10
	ld l,a
	ld h,sqt/256
	ld e,(hl):inc h
	ld d,(hl):dec h

	exa
	ld l,a
	exa
	ld a,l
y1: sub 10
	ld l,a
	ld a,(hl):inc h
	ld h,(hl):ld l,a
	add hl,de
	push hl

	ld a,c
	and 31
x2: sub 12
	ld l,a
	ld h,sqt/256
	ld e,(hl):inc h
	ld d,(hl):dec h
	
	exa
	ld l,a
	exa
	ld a,l
y2: sub 20
	ld l,a
	ld a,(hl):inc h
	ld h,(hl):ld l,a
	add hl,de
	pop de
	ld a,l
	xor e
	ld l,a
	ld a,h
	xor d
	ld h,a

	ld a,7
cd:
	sra h:rr l
	dec a:jr nz,cd
;	ld a,l
;	and 127
	ld h,ct/256
	ld a,(hl)

	ld (bc),a
	inc bc
	ld a,c
	and 31
	jr nz,xlp
	exa
	dec a
	jr nz,ylp
	ld hl,xx
	call move
	ld hl,xx
	call move
	ld (x1+1),a
	ld hl,yy
	call move
	ld (y1+1),a

	ld hl,xx1
	call move
	ld (x2+1),a
	ld hl,yy1
	call move
	ld (y2+1),a
	jp rlp ; jr $
move:
	push hl
	ld e,(hl):inc hl
	ld d,(hl):inc hl
	ld c,(hl);:inc hl
	
	ld a,e
	add a,d
	ld e,a
	jr z,chs
	cp c:jr nz,nochs
chs:
	ld a,d
	neg
	ld d,a
nochs:
	pop hl
	ld (hl),e:inc hl
	ld (hl),d
	ld a,e
	ret
xx: db 10,1,32
yy: db 10,1,24

xx1: db 20,1,32
yy1: db 20,1,24
colors:
 db 2,2*8+6,6*8+4,4*8+5,5*8+1,8
;	db $40+1
;	db $40+1+5*8
;	db $40+5+7*8
;	db $40+7+7*8
;	db $40+7+6*8
;	db $40+6+2*8
;	db $40+2+1*8
	db $FF
end
	display /d,end-begin
	savesna "!void.sna",begin

